// ------------------------------ Includes ------------------------------ //
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <array>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <iterator>
#include <numeric>
#include <complex>
#include <tuple>
#include <utility>
#include <cassert>
#include <assert.h>
#include <climits>
#include <limits.h>
#include <ctime>
#include <time.h>
#include <random>
#include <chrono>
#include <fstream>
using namespace std;

// ------------------------------ Typedefs ------------------------------ //

typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;

// ------------------------------ Defines ------------------------------ //

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

#define mset multiset
#define mmap multimap
#define uset unordered_set
#define umap unordered_map
#define pqueue priority_queue

#define sz(x) (int((x).size()))
#define len(x) (int((x).length()))
#define all(x) (x).begin(), (x).end()
#define clr(x) (x).clear()

#define ft front
#define bk back
#define pf push_front
#define pb push_back
#define popf pop_front
#define popb pop_back

#define lb lower_bound
#define ub upper_bound

// ------------------------------ Constants ------------------------------ //

const int MAX = int(1e9) + 5;
const ll MAXL = ll(1e18) + 5;
const ll MOD = ll(1e9 + 7);
const ll MOD2 = ll(998244353);

// ------------------------------ Functions ------------------------------ //

void fastio() { ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); }

void precision(int x) { cout << fixed << setprecision(x); }

ll gcd(ll a, ll b) { for (; b; swap(a, b)) a %= b; return a; }

ll lcm(ll a, ll b) { return a / gcd(a, b) * b; }

bool is_prime(ll a)
{
	if (a == 1) return false;
	if (a == 2) return true;
	if (!(a & 1)) return false;
	for (ll i = 3; i * i <= a; i += 2) if (a % i == 0) return false;
	return true;
}

bool is_square(ll a) { ll b = ll(sqrtl(ld(a))); return (b * b == a); }

bool is_cube(ll a) { ll b = ll(cbrtl(ld(a))); return (b * b * b == a); }

int digit_sum(ll a)
{
	int sum = 0;
	for (; a; a /= 10) sum += int(a % 10);
	return sum;
}

ll binpow(ll a, ll b, ll mod = 0)
{
	if (mod == 1) return 0;
	ll ans = 1;
	for (; b; b >>= 1) {
		if (b & 1) { ans *= a; if (mod) ans %= mod; }
		a *= a; if (mod) a %= mod;
	}
	return ans;
}

// ------------------------------ Solution ------------------------------ //

const int N = 105;
ll dp[N][(1 << 17) + 5][8];
int n, m, k;

ll fc[N * 2];

void sumu(ll& x, ll y)
{
	x = (x + y) % MOD2;
	return;
}

ll C(int n, int k)
{
	ll a = fc[n];
	ll b = (fc[k] * fc[n - k]) % MOD2;

	return (a * binpow(b, MOD2 - 2, MOD2)) % MOD2;
}

ll dp1[(1 << 16) + 5];
ll dp2[(1 << 16) + 5];
ll dp3[(1 << 16) + 5][25];
ll dp4[(1 << 16) + 5];

void solve()
{
	int i, j;

	cin >> n >> m >> k;

	string s;
	cin >> s;

	if (n > m) swap(n, m);

	if (n == 1) {
		cout << (binpow(2, m, MOD2) - 1 + MOD2) % MOD2 << "\n";
		return;
	}

	if (n == 2) {
		if (k == 1) {
			ll ans = m * 2;

			for (i = 1; i * 2 <= m; i++) {
				ans = (ans + C((m + 2 - i) - 1, (i + 1) - 1)) % MOD2;
			}

			cout << ans << "\n";
		}
		else {
			if(s[0] != s[1]) cout << (binpow(2, m, MOD2) - ll(m + 1) + MOD2) % MOD2 << "\n";
			else {
				ll ans = (binpow(2, m, MOD2) - 1 + MOD2) % MOD2;

				for (i = 1; i * 2 <= m; i++) {
					ans = (ans - C((m + 2 - i) - 1, (i + 1) - 1) + MOD2) % MOD2;
				}

				cout << ans << "\n";
			}
		}

		return;
	}

	int h = 0;

	for (i = 0; i < k; i++) {
		h += (1 << i) * int(s[i] - '0');
	}

	int mask, mm;
	int e = (1 << (k + 1)) + 1;

	for (i = 0; i < (1 << k); i++) {
		if (i != h) dp[k][0][i] = 1;
		else dp[k][(1 << (e - 1))][i] = 1;
	}

	for (i = k; i < max(n, m); i++) {
		for (mask = 0; mask < (1 << e); mask++) {
			for (j = 0; j < (1 << k); j++) {
				// add 0
				mm = (mask | (1 << j));
				if ((j / 2) == h) mm |= (1 << (e - 1));
				sumu(dp[i + 1][mm][(j / 2)], dp[i][mask][j]);
				// add 1
				mm = (mask | (1 << (j + (1 << k))));
				if ((j / 2) + (1 << (k - 1)) == h) mm |= (1 << (e - 1));
				sumu(dp[i + 1][mm][(j / 2) + (1 << (k - 1))], dp[i][mask][j]);
			}
		}
	}

	ll ans = 0;

	for (mask = 0; mask < (1 << e); mask++) {
		if (!(mask & (1 << (e - 1)))) continue;

		for (i = 0; i < (1 << k); i++) {
			dp1[(mask ^ (1 << (e - 1)))] += dp[n][mask][i];
			dp2[(mask ^ (1 << (e - 1)))] += dp[m][mask][i];
		}

		dp1[(mask ^ (1 << (e - 1)))] %= MOD2;
		dp2[(mask ^ (1 << (e - 1)))] %= MOD2;
	}

	e--;

	for (mask = 0; mask < (1 << e); mask++) {
		dp3[mask][0] = dp2[mask];
		for (i = 0; i < e; i++) {
			if (mask & (1 << i))
				dp3[mask][i + 1] = (dp3[mask][i] + dp3[mask ^ (1 << i)][i]) % MOD2;
			else
				dp3[mask][i + 1] = dp3[mask][i];
		}
		dp4[mask] = dp3[mask][e];
	}

	for (mask = 0; mask < (1 << e); mask++) {
		mm = mask ^ ((1 << e) - 1);

		ans += dp1[mask] * dp4[mm];

		ans %= MOD2;
	}

	cout << ans << "\n";

	return;
}

void precalc()
{
	int i, j;

	fc[0] = 1;

	for (i = 1; i <= 200; i++) fc[i] = (fc[i - 1] * ll(i)) % MOD2;

	return;
}

int main()
{
	fastio(); precalc();

	int tests = 1, tc;
	//cin >> tests;
	for (tc = 1; tc <= tests; tc++) { solve(); }

	return 0;
}

/*
	# # # #   # # # #   # # # #   #       #    #       #     #
	   #      #         #     #    #     #    # #      #   #
	   #      # # # #   #     #     #   #    #   #     # #
	   #            #   #     #      # #    # # # #    #   #
	   #      # # # #   # # # #       #    #       #   #     #
*/