#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <array>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <iterator>
#include <numeric>
#include <complex>
#include <utility>
#include <random>
#include <cassert>
#include <fstream>
using namespace std;
mt19937 rnd(time(nullptr));

/* -------------------- Typedefs -------------------- */

typedef int itn;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef float fl;
typedef long double ld;

/* -------------------- Usings -------------------- */

using vi = vector<int>;
using vll = vector<ll>;
using mii = map<int, int>;
using mll = map<ll, ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

/* -------------------- Defines -------------------- */

#define ff first
#define ss second
#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front
#define mpr make_pair
#define yes cout<<"Yes\n"
#define no cout<<"No\n"
#define all(x) (x).begin(), (x).end()
#define USACO freopen("feast.in", "r", stdin); freopen("feast.out", "w", stdout);

/* -------------------- Constants -------------------- */

const int dx[8] = { -1, 0, 1, 0, -1, -1, 1, 1 };
const int dy[8] = { 0, -1, 0, 1, -1, 1, -1, 1 };
const int MAX = int(1e9 + 5);
const ll MAXL = ll(1e18) + 5ll;
const ll MOD = ll(1000000007);
const ll MOD2 = ll(998244353);

/* -------------------- Functions -------------------- */

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void precision(int x) {
    cout.setf(ios::fixed | ios::showpoint);
    cout.precision(x);
}

ll gcd(ll a, ll b) {
    if (a == 0 || b == 0) return(max(a, b));
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}

ll range_sum(ll a, ll b) {
    if (a > b) return 0ll;
    ll dif = a - 1, cnt = b - a + 1;
    ll ans = ((b - a + 1) * (b - a + 2)) / 2;
    ans += ((b - a + 1) * dif);
    return ans;
}

string dec_to_bin(ll a) {
    string s = "";
    for (ll i = a; i > 0; ) {
        ll k = i % 2;
        i /= 2;
        char c = k + 48;
        s += c;
    }
    if (a == 0) {
        s = "0";
    }
    reverse(all(s));
    return s;
}

ll bin_to_dec(string s) {
    ll num = 0;
    for (int i = 0; i < s.size(); i++) {
        num *= 2ll;
        num += (s[i] - '0');
    }
    return num;
}

ll factorial_by_mod(ll n, ll mod) {
    ll ans = 1;
    ll num;
    for (ll i = 1; i <= n; ++i) {
        num = i % mod;
        ans *= num;
        ans %= mod;
    }
    return ans;
}

bool isPrime(ll a) {
    if (a == 1) return false;
    for (ll i = 2; i * i <= a; i++) {
        if (a % i == 0) return false;
    }
    return true;
}

ll binpow(ll a, ll b) {
    if (!a) return 0;
    ll ans = 1;
    while (b) {
        if (b & 1) {
            ans *= a;
        }
        b >>= 1;
        a *= a;
    }
    return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod) {
    if (!a) return 0;
    ll ans = 1;
    while (b) {
        if (b & 1) {
            ans *= a;
            ans %= mod;
        }
        b >>= 1;
        a *= a;
        a %= mod;
    }
    return ans;
}

/* -------------------- Solution -------------------- */

const int N = 100005;
vi g[N], g_rev[N], ord, comp[N];
int used[N], comp_id[N], dep[N], par[N], id[N], id_rev[N];
pii t[N * 4];
int n, m, gr = 0, node_cnt = 0;

void clr() {
    ord.clear();
    gr = node_cnt = 0;
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        g_rev[i].clear();
        comp[i].clear();
        used[i] = comp_id[i] = dep[i] = id[i] = id_rev[i] = 0;
    }
}

void bld(int l = 1, int r = n, int pos = 1) {
    t[pos].ff = 0;
    if (l == r) {
        t[pos].ss = l;
        par[l] = pos;
        return;
    }
    int mid = (l + r) / 2;
    bld(l, mid, 2 * pos);
    bld(mid + 1, r, 2 * pos + 1);
}

pii qry(int l, int r, int tl = 1, int tr = n, int pos = 1) {
    if (l == tl && r == tr) {
        return t[pos];
    }
    int mid = (tl + tr) / 2;
    if (mid >= r) {
        return qry(l, r, tl, mid, 2 * pos);
    }
    if (mid < l) {
        return qry(l, r, mid + 1, tr, 2 * pos + 1);
    }
    return min(qry(l, mid, tl, mid, 2 * pos), qry(mid + 1, r, mid + 1, tr, 2 * pos + 1));
}

void upd(int pos, int val, int type) {
    pos = par[pos];
    if (type == 1) {
        t[pos].ff = val;
    }
    else {
        t[pos].ff -= val;
    }
    pos /= 2;
    while (pos) {
        t[pos] = min(t[2 * pos], t[2 * pos + 1]);
        pos /= 2;
    }
}

void clr_used() {
    for (int i = 1; i <= n; ++i) {
        used[i] = 0;
    }
}

void dfs(int u) {
    used[u] = 1;
    for (auto to : g[u]) {
        if (used[to]) continue;
        dfs(to);
    }
    ord.pub(u);
}

void dfs1(int u) {
    used[u] = 1;
    comp[gr].pub(u);
    comp_id[u] = gr;
    for (auto to : g_rev[u]) {
        if (used[to]) continue;
        dfs1(to);
    }
}

void slv() {
    cin >> n >> m;
    clr();
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x].pub(y);
        g_rev[y].pub(x);
    }
    bld();
    for (int i = 1; i <= n; ++i) {
        if (used[i]) continue;
        dfs(i);
    }
    clr_used();
    reverse(all(ord));
    for (auto elem : ord) {
        if (used[elem]) continue;
        ++gr;
        dfs1(elem);
    }
    for (int u = 1; u <= n; ++u) {
        for (auto from : g_rev[u]) {
            if (comp_id[from] == comp_id[u]) {
                ++dep[u];
            }
        }
    }
    vi ans;
    clr_used();
    for (auto elem : ord) {
        if (used[elem]) continue;
        int cur_comp = comp_id[elem];
        int l = node_cnt + 1, r = -1;
        for (auto u : comp[cur_comp]) {
            used[u] = 1;
            ++node_cnt;
            upd(node_cnt, dep[u], 1);
            id_rev[u] = node_cnt;
            id[node_cnt] = u;
        }
        r = node_cnt;
        int len = r - l + 1;
        while (len--) {
            pii opt = qry(l, r);
            int node = opt.ss;
            ans.pub(id[node]);
            upd(node, MAX, 1);
            for (auto to : g[id[node]]) {
                upd(id_rev[to], 1, 2);
            }
        }
    }
    for (auto elem : ans) {
        cout << elem << " ";
    }
    cout << '\n';
}

/*
1
5 6
4 2
2 1
4 3
1 4
3 2
3 5
*/

void cs() {
    int tstc = 1;
    cin >> tstc;
    while (tstc--) {
        slv();
    }
}

void precalc() {
    return;
}

int main() {
    fastio();
    precalc();
    //precision(0);
    cs();
    return 0;
}