#include<iostream>
#include<vector>
#include<string>
#include<cmath>
using namespace std;

const int MOD = 998244353;

int mod_pow(int base, int exp, int mod) {
	int result = 1;
	while (exp > 0) 
	{
		if (exp % 2 == 1) {
			result = (1LL * result * base) % mod;
		}
		base = (1LL * base * base) % mod;
		exp /= 2;
	}
	return result;
}

int countStringWithSub(int length, const string& w) 
{
	int k = w.size();
	int total = mod_pow(2, length, MOD);

	vector<int> dp(length + 1, 0);
	dp[0] = 1;

	for (int i = 1; i <= length; ++i) {
		dp[i] = (2 * dp[i - 1]) % MOD;
		if (i >= k && w == w.substr(i - k, k)) {
			dp[i] = (dp[i] - dp[i - k] + MOD) % MOD;
		}
	}

	int invalid = dp[length];
	int valid = (total - invalid + MOD) % MOD;

	return valid;
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	string w;
	cin >> w;

	int valid_s = countStringWithSub(n,w);
	int valid_t = countStringWithSub(m,w);

	int total_pairs = (1LL * valid_s * valid_t) % MOD;
	cout << total_pairs << endl;
	return 0;
}