from itertools import product

MOD = 998244353


def longest_common_substring(s, t):
    n, m = len(s), len(t)
    dp = [[0] * (m + 1) for _ in range(n + 1)]
    max_length = 0
    substrings = set()

    for i in range(1, n + 1):
        for j in range(1, m + 1):
            if s[i - 1] == t[j - 1]:
                dp[i][j] = dp[i - 1][j - 1] + 1
                if dp[i][j] > max_length:
                    max_length = dp[i][j]
                    substrings = {s[i - dp[i][j]:i]}
                elif dp[i][j] == max_length:
                    substrings.add(s[i - dp[i][j]:i])

    return substrings


def count_pairs(n, m, k, w):
    all_s = [''.join(p) for p in product("01", repeat=n)]
    all_t = [''.join(p) for p in product("01", repeat=m)]
    count = 0

    for s in all_s:
        for t in all_t:
            common_substrings = longest_common_substring(s, t)
            if w in common_substrings:
                count += 1
                count %= MOD

    return count


n, m, k = map(int, input().split())
w = input().strip()

result = count_pairs(n, m, k, w)
print(result)