#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>

using namespace std;

using ll = long long;

vector<vector<int>> edges;
vector<int> marked;
vector<int> topSort;

void dfs(int node) {
	marked[node] = 1;
	for (int i = 0; i < edges[node].size(); ++i) {
		int next = edges[node][i];
		if (marked[next] == 0) {
			dfs(next);
		}
	}
	topSort.push_back(node + 1);
	marked[node] = 2;
}

void solve() {
	int n, m;
	std::cin >> n >> m;
	edges.assign(n, vector<int>());
	topSort.clear();
	for (int i = 0; i < m; ++i) {
		int u, v;
		std::cin >> u >> v;
		--u;
		--v;
		edges[u].push_back(v);
	}
	marked.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		if (marked[i] == 0) {
			dfs(i);
		}
	}
	reverse(topSort.begin(), topSort.end());
	for (auto x : topSort) {
		cout << x << ' ';
	}

	cout << endl;
}







void I_solve()
{
	ll n;
	cin >> n;
	vector<ll> p(n);
	vector<std::pair<ll, ll>> h(n);

	for (int i = 0; i < n; ++i)
		cin >> p[i];

	for (int i = 0; i < n; ++i)
	{
		cin >> h[i].first;
		//cout << h[i].first << endl;
		h[i].second = i;
	}
	

	vector<ll> diff(n);
	ll max_diff = 0;
	
	for (int i = 0; i < n; ++i)
	{
		diff[i] = h[i].first - p[i];
		//cout << diff[i] << endl;
		if (diff[i] < 0)
		{
			cout << "-1" << endl;
			return;
		}
		if (diff[i] > max_diff)
			max_diff = diff[i];
	}

	sort(h.begin(), h.end(), [](std::pair<ll, ll> p1, std::pair<ll, ll> p2) {return p1.first < p2.first;});

		for (int i = 0; i < n - 1; ++i)
		{
			//cout << h[i].first<< endl;
			if (!(p[h[i].second] <= p[h[i + 1].second]) || !(diff[h[i].second] <= diff[h[i + 1].second]))
			{
				cout << "-1" << endl;
				return;
			}
		}
	cout << max_diff << endl;
	return;
}
int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	int t;
	std::cin >> t;
	while (t-- > 0) {
		I_solve();
	}
}
