#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>

using namespace std;

using ll = long long;

vector<vector<int>> edges;
set<pair<int, int>> removed;
vector<int> marked;
vector<int> topSort;

void dfs(int node) {
	marked[node] = 1;
	for (int i = 0; i < edges[node].size(); ++i) {
		int next = edges[node][i];
		if (marked[next] == 1) {
			removed.emplace(node, next);
		}
		else if (marked[next] == 0) {
			dfs(next);
		}
	}
	topSort.push_back(node + 1);
	marked[node] = 2;
}

void solve() {
	int n, m;
	std::cin >> n >> m;
	edges.assign(n, vector<int>());
	removed.clear();
	topSort.clear();
	for (int i = 0; i < m; ++i) {
		int u, v;
		std::cin >> u >> v;
		--u;
		--v;
		edges[u].push_back(v);
	}
	marked.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		if (marked[i] == 0) {
			dfs(i);
		}
	}
	reverse(topSort.begin(), topSort.end());
	for (auto x : topSort) {
		cout << x << ' ';
	}

	cout << endl;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	int t;
	std::cin >> t;
	while (t-- > 0) {
		solve();
	}
}
