#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <queue>

using namespace std;

void solveCase(int n, int m, vector<pair<int, int>>& edges) 
{
    vector<int> inDegree(n + 1, 0), outDegree(n + 1, 0);
    vector<vector<int>> adj(n + 1);

   
    for (auto& edge : edges) 
    {
        int u = edge.first, v = edge.second;
        adj[u].push_back(v);
        outDegree[u]++;
        inDegree[v]++;
    }

   
    vector<int> nodes(n);
    for (int i = 1; i <= n; ++i) 
    {
        nodes[i - 1] = i;
    }
    sort(nodes.begin(), nodes.end(), [&](int a, int b) {
        return outDegree[a] > outDegree[b];
        });

    
    vector<int> position(n + 1);
    for (int i = 0; i < n; ++i)
    {
        position[nodes[i]] = i;
    }

    int consistentEdges = 0;
    for (auto& edge : edges) {
        if (position[edge.first] < position[edge.second])
        {
            consistentEdges++;
        }
    }

  
    if (consistentEdges >= (m + 1) / 2) 
    {
        for (int i = 0; i < n; ++i) 
        {
            cout << nodes[i] << " ";
        }
        cout << endl;
    }
    else 
    {
        cout << -1 << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t; 

    while (t--) {
        int n, m;
        cin >> n >> m;

        vector<pair<int, int>> edges(m);
        for (int i = 0; i < m; ++i) {
            cin >> edges[i].first >> edges[i].second;
        }

        solveCase(n, m, edges);
    }

    return 0;
}