#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <stack>
#include<list>
#include <algorithm>

using namespace std;
using ll = long long;

void dfs(vector<vector<int>>& graph, vector<int>& visited, int start, int& edge, int& back, vector<int>& order)
{
	visited[start] = 1;

	for (auto& neigh : graph[start])
	{
		if (visited[neigh] == 0)
		{
			edge++;
			dfs(graph, visited, neigh, edge, back, order);
		}
		else if (visited[neigh] == 1)
		{
			back++;
		}
		else if (visited[neigh] == 2)
		{
			edge++;
		}
	}

	order.push_back(start);
	visited[start] = 2;
}

int main() 
{
	/*std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);*/
	
	int t; cin >> t;
	for (int ti = 0; ti < t; ++ti)
	{
		int n, m; cin >> n >> m;
		vector<vector<int>> graph(n, vector<int>());
		std::vector<int> mtnox(n, 0);
		for (int mi = 0; mi < m; ++mi)
		{
			int a, b; cin >> a >> b;
			graph[a - 1].push_back(b - 1);
			mtnox[b - 1]++;
		}
		int min = *std::min_element(mtnox.begin(), mtnox.end());

		int edge = 0, back = 0;
		vector<int> visited(n, 0), order;

		priority_queue<pair<int, int>, vector<pair<int,int>>, greater<pair<int, int>>> pq;
		for (int i = 0; i < n; ++i)
		{
			pq.emplace(mtnox[i], i);
		}

		while(!pq.empty())
		{
			int start = pq.top().second;
			pq.pop();

			if(visited[start] == 0)
				dfs(graph, visited, start, edge, back, order);
		}
		cout << edge + back << " = " << m << endl;
		if (edge >= (m + 1) / 2)
		{
			reverse(order.begin(), order.end());
			for (auto& it : order)
			{
				cout << it +1 << " ";
			}
			cout << endl;
		}
		else
		{
			cout << -1 << "\n";
		}

	}
}
