def minimum_bricks(l, h):
    # Initialize the DP array where dp[i][j] represents the minimum number of 1x3 bricks needed
    dp = [[float('inf')] * (l + 1) for _ in range(h + 1)]

    # Base case: No bricks needed for a wall of height 0
    for j in range(l + 1):
        dp[0][j] = 0

    # Fill the DP table row by row
    for i in range(1, h + 1):
        for j in range(l + 1):
            # Option 1: Use a 1x2 brick if there's room for it
            if j >= 2:
                dp[i][j] = min(dp[i][j], dp[i][j - 2])

            # Option 2: Use a 1x3 brick if there's room for it
            if j >= 3:
                dp[i][j] = min(dp[i][j], dp[i - 1][j - 3] + 1)

            # Option 3: No additional bricks if length is exactly zero for this row
            if j == 0:
                dp[i][j] = dp[i - 1][j]

    # Result is the minimum number of 1x3 bricks needed for a wall of size l x h
    return dp[h][l]



l, h = map(int, input().split())
print(minimum_bricks(l, h))
