def erosion_years(test_cases):
    results = []
    for n, h, p in test_cases:
        # Step 1: Calculate erosion needed
        erosion_needed = [p[i] - h[i] for i in range(n)]

        # Step 2: If any erosion needed is negative, it's impossible
        if any(e < 0 for e in erosion_needed):
            results.append(-1)
            continue

        # Step 3: Calculate the maximum erosion needed
        max_erosion = max(erosion_needed)

        # Step 4: To check if it's possible in max_erosion years
        # All mountains must have the same or lower erosion as max_erosion
        possible = True
        for i in range(n):
            if erosion_needed[i] > max_erosion:
                possible = False
                break

        # Step 5: If possible, the answer is max_erosion, otherwise -1
        if possible:
            results.append(max_erosion)
        else:
            results.append(-1)

    return results


# Input processing
t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    h = list(map(int, input().split()))
    p = list(map(int, input().split()))
    test_cases.append((n, h, p))

# Compute and print results
results = erosion_years(test_cases)
print("\n".join(map(str, results)))