def erosion_years(test_cases):
    results = []
    for n, h, p in test_cases:
        # Step 1: Calculate the erosion needed
        erosion_needed = [p[i] - h[i] for i in range(n)]

        # Step 2: If any erosion_needed is negative, it's impossible (mountain cannot grow)
        if any(e < 0 for e in erosion_needed):
            results.append(-1)
            continue

        # Step 3: The answer for the test case is the maximum erosion required
        max_erosion = max(erosion_needed)

        # Step 4: Append the result
        results.append(max_erosion)

    return results


# Input processing
t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    h = list(map(int, input().split()))
    p = list(map(int, input().split()))
    test_cases.append((n, h, p))

# Compute and print results
results = erosion_years(test_cases)
print("\n".join(map(str, results)))