from itertools import combinations

def min_bricks(l, h):
    def generate_rows(length):
        rows = []
        for num_seams in range(length // 2 + 1):
            for seams in combinations(range(1, length), num_seams):
                row = []
                prev = 0
                valid = True
                for seam in seams:
                    brick = seam - prev
                    if brick not in (2, 3):
                        valid = False
                        break
                    row.append(brick)
                    prev = seam
                if valid and (length - prev) in (2, 3):
                    row.append(length - prev)
                    rows.append((row, seams))
        return rows

    def compatible(row1, row2):
        _, seams1 = row1
        _, seams2 = row2
        return not any(seam in seams1 for seam in seams2)

    rows = generate_rows(l)
    row_count = len(rows)

    graph = [[] for _ in range(row_count)]
    for i in range(row_count):
        for j in range(row_count):
            if compatible(rows[i], rows[j]):
                graph[i].append(j)

    dp = [[float('inf')] * row_count for _ in range(h)]
    for i, (row, _) in enumerate(rows):
        dp[0][i] = row.count(3)

    for level in range(1, h):
        for i in range(row_count):
            for prev in graph[i]:
                dp[level][i] = min(dp[level][i], dp[level - 1][prev] + rows[i][0].count(3))

    return min(dp[h - 1])

l, h = map(int, input().split())

print(min_bricks(l, h))
