def count_pairs_with_longest_common_substring(n, m, k, w):
    MOD = 998244353

    # Function to compute the length of the longest common substring using dynamic programming
    def longest_common_substring_length(s, t):
        dp = [[0] * (len(t) + 1) for _ in range(len(s) + 1)]
        longest = 0
        for i in range(1, len(s) + 1):
            for j in range(1, len(t) + 1):
                if s[i - 1] == t[j - 1]:
                    dp[i][j] = dp[i - 1][j - 1] + 1
                    longest = max(longest, dp[i][j])
        return longest

    # Precompute all binary strings of length n and m
    def generate_binary_strings(length):
        return [format(i, f"0{length}b") for i in range(2**length)]

    strings_s = generate_binary_strings(n)
    strings_t = generate_binary_strings(m)

    count = 0
    # Check pairs of strings from strings_s and strings_t
    for s in strings_s:
        for t in strings_t:
            if longest_common_substring_length(s, t) == len(w) and w in s and w in t:
                count += 1
                count %= MOD

    return count


# Input
n, m, k = map(int, input().split())
w = input()

# Output
result = count_pairs_with_longest_common_substring(n, m, k, w)
print(result)
