
import java.util.*;

public class Main {

    private static int timeToMinutes(String time) {
        String[] parts = time.split(":");
        int hours = Integer.parseInt(parts[0]);
        int minutes = Integer.parseInt(parts[1]);
        return (hours - 7) * 60 + minutes;
    }

    public static int countAdditionalAlarms(int n, List<String> alarms) {
        List<Integer> alarmMinutes = new ArrayList<>();
        for (String alarm : alarms) {
            alarmMinutes.add(timeToMinutes(alarm));
        }
        Collections.sort(alarmMinutes);

        int minAdditionalAlarms = Integer.MAX_VALUE;

        for (int i = 0; i < alarmMinutes.size(); i++) {
            int count = 1;
            for (int j = i + 1; j < alarmMinutes.size(); j++) {
                if (alarmMinutes.get(j) - alarmMinutes.get(i) <= 10) {
                    count++;
                } else {
                    break;
                }
            }

            if (count < 3) {
                int additionalAlarms = 3 - count;
                minAdditionalAlarms = Math.min(minAdditionalAlarms, additionalAlarms);
            } else {

                minAdditionalAlarms = 0;
            }
        }

        return minAdditionalAlarms;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        scanner.nextLine();

        List<String> alarms = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            alarms.add(scanner.nextLine().trim());
        }

        int result = countAdditionalAlarms(n, alarms);
        System.out.println(result);
    }
}