import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static int solve(int mountainsCount, int[] finalHeights, int[] startHeights) {
        int[] delta = new int[mountainsCount];
        for (int i = 0; i < mountainsCount; i++) {
            delta[i] = startHeights[i] - finalHeights[i];
        }

        int[] sortedStart = startHeights.clone();
        int[] sortedEnd = finalHeights.clone();
        int[] sortedDelta = new int[mountainsCount];

        Arrays.sort(sortedStart);
        Arrays.sort(sortedEnd);

        for (int i = 0; i < mountainsCount; i++) {
            sortedDelta[i] = sortedStart[i] - sortedEnd[i];
        }

        int[] tempDelta = delta.clone();
        Arrays.sort(tempDelta);

        for (int i = 0; i < mountainsCount; i++) {
            if (sortedDelta[i] != tempDelta[i]) {
                return -1;
            }
        }

        boolean isZero = false;
        for (int i = 0; i < finalHeights.length; i++) {
            int diff = startHeights[i] - finalHeights[i];
            if (diff < 0) {
                return -1;
            } else if (diff == 0) {
                isZero = true;
            }
        }

        int maxStartHeight = Arrays.stream(startHeights).max().getAsInt();
        int maxIndex = indexOf(startHeights, maxStartHeight);
        int maxFinalHeight = finalHeights[maxIndex];
        int diff = maxStartHeight - maxFinalHeight;

        if (diff < Arrays.stream(delta).max().getAsInt()) {
            return -1;
        } else {
            return diff;
        }
    }

    private static int indexOf(int[] array, int value) {
        for (int i = 0; i < array.length; i++) {
            if (array[i] == value) {
                return i;
            }
        }
        return -1; // In case not found, though it shouldn't happen
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int testCount = scanner.nextInt();
        scanner.nextLine(); // Consume the leftover newline

        for (int i = 0; i < testCount; i++) {
            int mountainsCount = scanner.nextInt();
            scanner.nextLine(); // Consume the leftover newline

            int[] finalHeights = Arrays.stream(scanner.nextLine().split(" "))
                    .mapToInt(Integer::parseInt)
                    .toArray();

            int[] startHeights = Arrays.stream(scanner.nextLine().split(" "))
                    .mapToInt(Integer::parseInt)
                    .toArray();

            System.out.println(solve(mountainsCount, finalHeights, startHeights));
        }
        scanner.close();
    }
}
