from itertools import product

def min_bricks(l, h):
    # Generate all possible valid rows and track seams and 1x3 usage
    def generate_rows(length):
        configs = []
        def backtrack(remaining, row, seams, count_1x3, pos):
            if remaining == 0:
                configs.append((row[:], set(seams), count_1x3))
                return
            if remaining >= 2:
                row.append(2)
                backtrack(remaining - 2, row, seams + [pos + 2], count_1x3, pos + 2)
                row.pop()
            if remaining >= 3:
                row.append(3)
                backtrack(remaining - 3, row, seams + [pos + 3], count_1x3 + 1, pos + 3)
                row.pop()
        
        backtrack(length, [], [], 0, 0)
        return configs

    rows = generate_rows(l)
    dp = [[float('inf')] * len(rows) for _ in range(h)]
    
    # Initialize the first row
    for i, (_, _, count_1x3) in enumerate(rows):
        dp[0][i] = count_1x3
    
    # Fill DP table
    for i in range(1, h):
        for j, (_, seams1, count1) in enumerate(rows):
            for k, (_, seams2, count2) in enumerate(rows):
                if seams1.isdisjoint(seams2):  # Ensure no seams align
                    dp[i][j] = min(dp[i][j], dp[i - 1][k] + count1)
    
    # Find the minimum value in the last row
    return min(dp[h - 1])

# Input
l, h = map(int, input().split())

# Output
print(min_bricks(l, h))