#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int countTangentialCircles(const vector<tuple<int, int, int>>& circles) {
    int count = 0;

    for (size_t i = 0; i < circles.size(); ++i) {
        auto [x1, y1, r1] = circles[i];
        for (size_t j = i + 1; j < circles.size(); ++j) {
            auto [x2, y2, r2] = circles[j];

            double d = sqrt(pow(x2 - x1, 2) + pow(y2 - y1, 2));

            if ((d == r1 + r2 || d == abs(r1 - r2)) && d > abs(r1 - r2)) {
                count++;
            }
        }
    }

    return count;
}

int main() {
    int testCount;
    cin >> testCount;

    for (int test = 0; test < testCount; ++test) {
        int circlesCount;
        cin >> circlesCount;

        vector<tuple<int, int, int>> circles(circlesCount);
        for (int i = 0; i < circlesCount; ++i) {
            int x, y, r;
            cin >> x >> y >> r;
            circles[i] = {x, y, r};
        }

        cout << countTangentialCircles(circles) << endl;
    }

    return 0;
}