#include <iostream>
#include <vector>
#include <cmath>
#include <tuple>
using namespace std;

int countTangentialCircles(const vector<tuple<int, int, int>>& circles) {
    int count = 0;

    for (size_t i = 0; i < circles.size(); ++i) {
        auto [x1, y1, r1] = circles[i];
        for (size_t j = i + 1; j < circles.size(); ++j) {
            auto [x2, y2, r2] = circles[j];

            int dx = x2 - x1;
            int dy = y2 - y1;
            int d2 = dx * dx + dy * dy;

            int rSum = r1 + r2;
            int rDiff = abs(r1 - r2);
            int rSum2 = rSum * rSum;
            int rDiff2 = rDiff * rDiff;

            if ((d2 == rSum2 || d2 == rDiff2) && d2 > rDiff2) {
                count++;
            }
        }
    }

    return count;
}

int main() {
    int testCount;
    cin >> testCount;

    for (int test = 0; test < testCount; ++test) {
        int circlesCount;
        cin >> circlesCount;

        vector<tuple<int, int, int>> circles(circlesCount);
        for (int i = 0; i < circlesCount; ++i) {
            int x, y, r;
            cin >> x >> y >> r;
            circles[i] = {x, y, r};
        }

        cout << countTangentialCircles(circles) << endl;
    }

    return 0;
}