#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

// Function to convert time (h:mm) to minutes since 7:00
int toMinutes(int h, int m) {
    return (h - 7) * 60 + m;
}

// Function to check if three alarms within 10 minutes exist
bool check(const vector<int>& alarms) {
    for (size_t i = 0; i < alarms.size(); ++i) {
        for (size_t j = i + 1; j < alarms.size(); ++j) {
            for (size_t k = j + 1; k < alarms.size(); ++k) {
                if (alarms[k] - alarms[i] <= 10) {
                    return true;
                }
            }
        }
    }
    return false;
}

// Function to find the minimum additional alarms needed
int findMinimumAlarms(vector<int> alarms) {
    sort(alarms.begin(), alarms.end());
    if (check(alarms)) return 0;

    int additional = 0;
    set<int> allAlarms(alarms.begin(), alarms.end());

    // Try adding alarms and check
    for (int i = 1; i <= 2; ++i) {  // At most 2 additional alarms
        additional++;
        for (int t1 = 0; t1 <= 120; ++t1) {  // All possible times from 7:00 to 9:00
            if (allAlarms.count(t1)) continue;  // Skip existing alarms
            allAlarms.insert(t1);

            // Add one more alarm if needed
            if (i == 2) {
                for (int t2 = 0; t2 <= 120; ++t2) {
                    if (allAlarms.count(t2)) continue;
                    allAlarms.insert(t2);

                    // Check the condition
                    vector<int> currentAlarms(allAlarms.begin(), allAlarms.end());
                    if (check(currentAlarms)) return additional;

                    allAlarms.erase(t2);
                }
            } else {
                vector<int> currentAlarms(allAlarms.begin(), allAlarms.end());
                if (check(currentAlarms)) return additional;
            }

            allAlarms.erase(t1);
        }
    }

    return additional;
}

int main() {
    int n;
    cin >> n;

    vector<int> alarms;
    for (int i = 0; i < n; ++i) {
        string time;
        cin >> time;

        int h = stoi(time.substr(0, time.find(':')));
        int m = stoi(time.substr(time.find(':') + 1));
        alarms.push_back(toMinutes(h, m));
    }

    cout << findMinimumAlarms(alarms) << endl;
    return 0;
}