#include <iostream>
#include <vector>
#include <utility>

using namespace std;

// Function to read input values
void read_input(int& n, int& m, vector<pair<int, int>>& pairs) {
    cin >> n >> m;
    pairs.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> pairs[i].first >> pairs[i].second;
    }
}

// Function to count how many pairs satisfy the condition: first < second
int count_valid_pairs(const vector<pair<int, int>>& pairs) {
    int count = 0;
    for (const auto& p : pairs) {
        if (p.first < p.second) {
            count++;
        }
    }
    return count;
}

// Function to print the sequence in ascending order
void print_ascending(int n) {
    for (int i = 1; i <= n; i++) {
        cout << i << ' ';
    }
    cout << "\n";
}

// Function to print the sequence in descending order
void print_descending(int n) {
    for (int i = n; i >= 1; i--) {
        cout << i << ' ';
    }
    cout << "\n";
}

// Function to solve the problem
void solve() {
    int n, m;
    vector<pair<int, int>> pairs;
    
    // Read input values
    read_input(n, m, pairs);
    
    // Count how many pairs satisfy the condition
    int cnt = count_valid_pairs(pairs);
    
    // Output the sequence based on the condition
    if (cnt * 2 >= m) {
        print_ascending(n);
    } else {
        print_descending(n);
    }
}

// Main function
int main() {
    solve();
    return 0;
}
